use serde::Deserialize;
use std::collections::HashMap;

pub mod client;
pub mod error;
pub mod methods;

pub type Result<T> = std::result::Result<T, error::ApiError>;

#[derive(Deserialize)]
pub struct VersionApiResp {
    pub versions: Vec<String>,
    pub unstable_features: HashMap<String, bool>,
}
